builtin add_int : int -> int -> int;
builtin eq_int : int -> int -> bool;

type list 'a =
  [ Cons : 'a * (list 'a)
  | Nil ]
;

type nat =
  [ S : nat
  | Z ]
;

value not = fun x =>
  match x with
    [ True => False
    | False => True ];

value add = (fix add x => fun y =>
  (match x with
  [ Z => y
  | S x => S (add x y)]));

value mul = (fix mul x => fun y =>
    (match x with
     [ Z => Z
     | S x => add (mul x y) y]));

value map = fix map f => fun l =>
  match l with
  [ Nil => Nil
  | Cons(elt, tail) => Cons(f elt, map f tail) ];

value three = S (S (S Z));

value list = Cons(three,Cons(S three, Cons(Z, Nil)));

main = map (fun x => mul x three) list
